package hep.wired.corbaheprep;

import hep.wired.hepeventserver.idl.HepEventServer;
import hep.wired.hepeventserver.idl.HepEventServerHelper;
import hep.wired.jprocman.Goal;
import hep.wired.jprocman.GoalSet;
import hep.wired.jprocman.ProcManClient;
import hep.wired.jprocman.ProcProxy;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.Iterator;
import java.util.Vector;

import org.omg.CORBA.ORB;

public class Read {

    public Read() {
    }

    public void run(String[] args) throws Exception {
        ORB orb = ORB.init(args, System.getProperties());

        String webServer = "http://www.slac.stanford.edu/~wiredces/prodservers.ior";
        BufferedReader in = new BufferedReader(new InputStreamReader(new URL(
                webServer).openStream()));
        // FIXME, we may be able to read more than one line.
        String iorString = in.readLine();
        in.close();
        System.out.println(iorString);
        // org.omg.CORBA.Object corbaObject = orb.string_to_object(iorString);
        // System.out.println(corbaObject);
        // FIXME, check if this is an HepEventServer
        ProcManClient procManClient = new ProcManClient(iorString);
        GoalSet goalSet = procManClient.getGoalSetWithProcs();
        System.out.println(goalSet.getName() + " " + goalSet.getDesc());
        Vector goals = goalSet.getGoals();
        for (Iterator i = goals.iterator(); i.hasNext();) {
            Goal goal = (Goal) i.next();
            if (goal.getDesc().indexOf("HepEventServer") >= 0) {
                if (goal.isDown()) {
                    System.out.println(goal.getName() + " down until: "
                            + goal.getOutageEstEndTime() + " due to: "
                            + goal.getOutageReason());
                } else {
                    System.out.println(goal.getName());
                    Vector proxies = goal.getProcProxies();
                    for (Iterator j = proxies.iterator(); j.hasNext();) {
                        ProcProxy proxy = (ProcProxy) j.next();
                        if (proxy.getStatus().equals("ready")) {
                            String ior = proxy.getIOR();
                            if (!ior.equals("undefined")) {
                                org.omg.CORBA.Object server = orb
                                        .string_to_object(ior);
                                HepEventServer hepEventServer = HepEventServerHelper
                                        .narrow(server);
                                if (hepEventServer != null) {
                                    System.out.println("===="
                                            + "n = "
                                            + hepEventServer
                                                    .getNumberOfEvents());
                                    /*
                                     * String user = "Mowgli@Jungle"; String
                                     * client =
                                     * "client=JungleBook;version=1.0;user="+user+";";
                                     * String response =
                                     * hepEventServer.attach(client); String[]
                                     * keyValues = response.split(";"); for (int
                                     * k=0; k<keyValues.length; k++) { String[]
                                     * keyValue = keyValues[k].split("=", 2);
                                     * System.out.println(" "+keyValue[0]+" =
                                     * "+keyValue[1]); if
                                     * (keyValue[0].trim().equals("defaultEventID")) {
                                     * String id =
                                     * hepEventServer.setEvent(keyValue[1].trim());
                                     * System.out.println("--->"+id);
                                     * System.out.println("
                                     * "+hepEventServer.getEventTitle()); } }
                                     * hepEventServer.release();
                                     */
                                }
                                break;
                            }
                        } else {
                            System.out.println("   " + proxy.getStatus() + " "
                                    + proxy.getStatusDetail());
                        }
                    }
                }
            }
        }
        System.out.println("Done");
    }

    public static void main(String[] args) throws Exception {
        Read r = new Read();
        r.run(args);
    }
}
